// Auto-generated. Do not edit!

// (in-package lex_common_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let audio_common_msgs = _finder('audio_common_msgs');

//-----------------------------------------------------------

let KeyValue = require('../msg/KeyValue.js');

//-----------------------------------------------------------

class AudioTextConversationRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.content_type = null;
      this.accept_type = null;
      this.text_request = null;
      this.audio_request = null;
    }
    else {
      if (initObj.hasOwnProperty('content_type')) {
        this.content_type = initObj.content_type
      }
      else {
        this.content_type = '';
      }
      if (initObj.hasOwnProperty('accept_type')) {
        this.accept_type = initObj.accept_type
      }
      else {
        this.accept_type = '';
      }
      if (initObj.hasOwnProperty('text_request')) {
        this.text_request = initObj.text_request
      }
      else {
        this.text_request = '';
      }
      if (initObj.hasOwnProperty('audio_request')) {
        this.audio_request = initObj.audio_request
      }
      else {
        this.audio_request = new audio_common_msgs.msg.AudioData();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AudioTextConversationRequest
    // Serialize message field [content_type]
    bufferOffset = _serializer.string(obj.content_type, buffer, bufferOffset);
    // Serialize message field [accept_type]
    bufferOffset = _serializer.string(obj.accept_type, buffer, bufferOffset);
    // Serialize message field [text_request]
    bufferOffset = _serializer.string(obj.text_request, buffer, bufferOffset);
    // Serialize message field [audio_request]
    bufferOffset = audio_common_msgs.msg.AudioData.serialize(obj.audio_request, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AudioTextConversationRequest
    let len;
    let data = new AudioTextConversationRequest(null);
    // Deserialize message field [content_type]
    data.content_type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [accept_type]
    data.accept_type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [text_request]
    data.text_request = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [audio_request]
    data.audio_request = audio_common_msgs.msg.AudioData.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.content_type.length;
    length += object.accept_type.length;
    length += object.text_request.length;
    length += audio_common_msgs.msg.AudioData.getMessageSize(object.audio_request);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'lex_common_msgs/AudioTextConversationRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '798c931cb0c2170cb81c5835991b89ed';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # type corresponds to https://docs.aws.amazon.com/lex/latest/dg/API_runtime_PostContent.html content_type
    string content_type
    string accept_type
    string text_request
    # used audio data for convenience to work with audio_common
    audio_common_msgs/AudioData audio_request
    
    ================================================================================
    MSG: audio_common_msgs/AudioData
    uint8[] data
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AudioTextConversationRequest(null);
    if (msg.content_type !== undefined) {
      resolved.content_type = msg.content_type;
    }
    else {
      resolved.content_type = ''
    }

    if (msg.accept_type !== undefined) {
      resolved.accept_type = msg.accept_type;
    }
    else {
      resolved.accept_type = ''
    }

    if (msg.text_request !== undefined) {
      resolved.text_request = msg.text_request;
    }
    else {
      resolved.text_request = ''
    }

    if (msg.audio_request !== undefined) {
      resolved.audio_request = audio_common_msgs.msg.AudioData.Resolve(msg.audio_request)
    }
    else {
      resolved.audio_request = new audio_common_msgs.msg.AudioData()
    }

    return resolved;
    }
};

class AudioTextConversationResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.text_response = null;
      this.audio_response = null;
      this.slots = null;
      this.intent_name = null;
      this.message_format_type = null;
      this.dialog_state = null;
    }
    else {
      if (initObj.hasOwnProperty('text_response')) {
        this.text_response = initObj.text_response
      }
      else {
        this.text_response = '';
      }
      if (initObj.hasOwnProperty('audio_response')) {
        this.audio_response = initObj.audio_response
      }
      else {
        this.audio_response = new audio_common_msgs.msg.AudioData();
      }
      if (initObj.hasOwnProperty('slots')) {
        this.slots = initObj.slots
      }
      else {
        this.slots = [];
      }
      if (initObj.hasOwnProperty('intent_name')) {
        this.intent_name = initObj.intent_name
      }
      else {
        this.intent_name = '';
      }
      if (initObj.hasOwnProperty('message_format_type')) {
        this.message_format_type = initObj.message_format_type
      }
      else {
        this.message_format_type = '';
      }
      if (initObj.hasOwnProperty('dialog_state')) {
        this.dialog_state = initObj.dialog_state
      }
      else {
        this.dialog_state = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AudioTextConversationResponse
    // Serialize message field [text_response]
    bufferOffset = _serializer.string(obj.text_response, buffer, bufferOffset);
    // Serialize message field [audio_response]
    bufferOffset = audio_common_msgs.msg.AudioData.serialize(obj.audio_response, buffer, bufferOffset);
    // Serialize message field [slots]
    // Serialize the length for message field [slots]
    bufferOffset = _serializer.uint32(obj.slots.length, buffer, bufferOffset);
    obj.slots.forEach((val) => {
      bufferOffset = KeyValue.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [intent_name]
    bufferOffset = _serializer.string(obj.intent_name, buffer, bufferOffset);
    // Serialize message field [message_format_type]
    bufferOffset = _serializer.string(obj.message_format_type, buffer, bufferOffset);
    // Serialize message field [dialog_state]
    bufferOffset = _serializer.string(obj.dialog_state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AudioTextConversationResponse
    let len;
    let data = new AudioTextConversationResponse(null);
    // Deserialize message field [text_response]
    data.text_response = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [audio_response]
    data.audio_response = audio_common_msgs.msg.AudioData.deserialize(buffer, bufferOffset);
    // Deserialize message field [slots]
    // Deserialize array length for message field [slots]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.slots = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.slots[i] = KeyValue.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [intent_name]
    data.intent_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [message_format_type]
    data.message_format_type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [dialog_state]
    data.dialog_state = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.text_response.length;
    length += audio_common_msgs.msg.AudioData.getMessageSize(object.audio_response);
    object.slots.forEach((val) => {
      length += KeyValue.getMessageSize(val);
    });
    length += object.intent_name.length;
    length += object.message_format_type.length;
    length += object.dialog_state.length;
    return length + 20;
  }

  static datatype() {
    // Returns string type for a service object
    return 'lex_common_msgs/AudioTextConversationResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '755f1eb03168c9e237363764c62fb10c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string text_response
    audio_common_msgs/AudioData audio_response
    lex_common_msgs/KeyValue[] slots
    string intent_name
    string message_format_type
    string dialog_state
    
    
    ================================================================================
    MSG: audio_common_msgs/AudioData
    uint8[] data
    
    ================================================================================
    MSG: lex_common_msgs/KeyValue
    string key
    string value
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AudioTextConversationResponse(null);
    if (msg.text_response !== undefined) {
      resolved.text_response = msg.text_response;
    }
    else {
      resolved.text_response = ''
    }

    if (msg.audio_response !== undefined) {
      resolved.audio_response = audio_common_msgs.msg.AudioData.Resolve(msg.audio_response)
    }
    else {
      resolved.audio_response = new audio_common_msgs.msg.AudioData()
    }

    if (msg.slots !== undefined) {
      resolved.slots = new Array(msg.slots.length);
      for (let i = 0; i < resolved.slots.length; ++i) {
        resolved.slots[i] = KeyValue.Resolve(msg.slots[i]);
      }
    }
    else {
      resolved.slots = []
    }

    if (msg.intent_name !== undefined) {
      resolved.intent_name = msg.intent_name;
    }
    else {
      resolved.intent_name = ''
    }

    if (msg.message_format_type !== undefined) {
      resolved.message_format_type = msg.message_format_type;
    }
    else {
      resolved.message_format_type = ''
    }

    if (msg.dialog_state !== undefined) {
      resolved.dialog_state = msg.dialog_state;
    }
    else {
      resolved.dialog_state = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: AudioTextConversationRequest,
  Response: AudioTextConversationResponse,
  md5sum() { return '9f8d745d5015035e2674298237ee09da'; },
  datatype() { return 'lex_common_msgs/AudioTextConversation'; }
};
